package com.engine.salary.mapper.auth;

import com.engine.salary.entity.auth.param.AuthRoleListQueryParam;
import com.engine.salary.entity.auth.po.AuthRolePO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface AuthRoleMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<AuthRolePO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<AuthRolePO> listSome(AuthRolePO authRole);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    AuthRolePO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param authRole 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(AuthRolePO authRole);

    /**
     * 修改，修改所有字段
     *
     * @param authRole 修改的记录
     * @return 返回影响行数
     */
    int update(AuthRolePO authRole);

    /**
     * 修改，忽略null字段
     *
     * @param authRole 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(AuthRolePO authRole);

    /**
     * 删除记录
     *
     * @param authRole 待删除的记录
     * @return 返回影响行数
     */
    int delete(AuthRolePO authRole);

    /**
     * 批量删除记录
     *
     * @param ids 主键id集合
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);


    List<AuthRolePO> list(AuthRoleListQueryParam param);
}